# CENTER-TBI six-months GOSe-Outcome Imputation

# Prerequisites

We assume a Unix command line workflow. The following software is required to take advantage of the pre-defined workflow:
  * curl for downloading the data (in case you do not have curl installed, it is also available from within the container)
  * [python](https://www.python.org/download/releases/3.5.1/) 3.5.1 (higher versions might work as well) 
  * [snakemake](https://snakemake.readthedocs.io/en/stable/getting_started/installation.html) version 5.2.1 (higher versions will work as well)
  * [singularity](https://www.sylabs.io/guides/2.6/user-guide/index.html) 2.6.0 (higher versions might work as well)
  
+ CENTER-TBI account and API key, store as NEUROBOT_USR and NEUROBOT_API 
environment variables.

The entire analysis is containerized using a [docker container](https://cloud.docker.com/u/kkmann/repository/docker/kkmann/gose-6mo-imputation). 
The container can either be used to execute scripts individually inside the container, or it can be used to run the entire 
pre-defined snakemake workflow using the container via singularity (recommended).
A [script](https://github.com/kkmann/center-6mo-gose-imputation/blob/master/snakemake_slurm) for running the entire analysis 
on a slurm cluster is provided. 
Make sure to adjust the parameters in the [cluster configuration file](https://github.com/kkmann/center-6mo-gose-imputation/blob/master/cluster.json) 
accordingly.

A [script](https://github.com/kkmann/center-6mo-gose-imputation/blob/master/snakemake) for execution on a single desktop 
machine is provided as well. Depending on the number of cores and available RAM, the cross-validated model comparison may take several 
days (3+) to complete.
The script can be invoked via
```
./snakemake_slurm [target]
```
where `[target]` is the build target (e.g. 'data_report_v1_1').


# Executing the workflow

The available rules can be listed by invoking
```
snakemake -lt
```


To reproduce the data extraction an population description on version v1.1 of the neurobot CENTER-TBI data, invoke 
```
./snakemake_slurm data_report_v1_1
```

To reproduce the cross-validated model comparison on version v1.1 of the neurobot CENTER-TBI data, invoke 
```
./snakemake_slurm cv_model_comparison_report_v1_1
```


To reproduce the MSM model-based imputation for v1.1 of the neurobot CENTER-TBI data, invoke 
```
./snakemake_slurm cv_model_comparison_report_v1_1
```
